/*
 * Station.java
 *
 * Created on December 24, 2004, 4:52 PM
 */

/**
 * Station is a simple class that contains a callsign and grid square
 * along with accessors for that data.
 * @author Andrew T. Flowers, K0SM
 */
public class Station {

    private String call;
    private String grid;

    /** Creates a new instance of Station */
    public Station() {
    }

    /**
     * Constructor that initializes the callsign and grid of the station.
     * @param callsign The callsign of the station
     * @param gridSquare The gridsquare of the station
     */
    public Station(String callsign, String gridSquare) {
        call = callsign;
        grid = gridSquare;
    }

    /**
     * Accessor to get callsign of this station
     * @return  String representing this stations callsign
     */
    public String getCall() {
        return call;
    }

    /**
     * Accessor to get grid square of this station
     * @return String representing this stations grid square
     */
    public String getGrid() {
        return grid;
    }
}
