


import javax.swing.event.*;
import javax.swing.table.TableModel;
import javax.swing.table.*;
import javax.swing.*;
import java.awt.event.MouseEvent;

public class StormViewerPane extends javax.swing.JPanel {
    final RainScatter MAIN_PROGRAM = (RainScatter)RainScatter.getFrames()[0];
    
    
    java.util.Vector stormData;
    public javax.swing.JTable table;
    java.util.Vector columnNames;
    java.util.Vector stormTableVector;
    
    protected String[] columnToolTips = {"Location of storm",
    "Height of Storm top (1000's ft)",
    "Max reflectivity of storm",
    "Height of max reflectivity",
    "Direction of movement (deg)",
    "Speed of movement(knots)",
    "Storm ID",
    "Tornadic Vortex Signature",
    "Mesocyclone Signature",
    "Possiblity of severe hail",
    "Possibility of hail",
    "Predicted max size of hail (in)",
    "Vertically integrated liquid water (kg/m^2)",
    "Reporting radar"};
    
    /** Creates empty StormViewer */
    public StormViewerPane() {
        
        initComponents();
        
        
    }
    
    /** Creates a StormViewer for the particular stormTable data */
    public StormViewerPane(final java.util.Vector stormTable) {
        
        initComponents();
        
        
        stormTableVector = new java.util.Vector();
        
        int numberOfStorms = stormTable.size();
        Object[][] RowData;

        for (int i = 0; i < stormTable.size(); i++) {
            Storm storm = (Storm)stormTable.elementAt(i);
            java.util.Vector lineData = addStorm(storm);
            stormTableVector.add(lineData);
        }
        
        //JTable table = new JTable(new MyTableModel()) {
            table = new JTable(new MyTableModel()) {
            //Implement table header tool tips.
            protected JTableHeader createDefaultTableHeader() {
                return new JTableHeader(columnModel) {
                    public String getToolTipText(MouseEvent e) {
                        String tip = null;
                        java.awt.Point p = e.getPoint();
                        int index = columnModel.getColumnIndexAtX(p.x);
                        int realIndex = columnModel.getColumn(index).getModelIndex();
                        return columnToolTips[realIndex];
                    }
                };
            }
            
        };
        
        TableColumn column = null;
        for (int i = 0; i < table.getColumnCount(); i++) {
            column = table.getColumnModel().getColumn(i);
            switch (i) {
                
                    case 0: {column.setPreferredWidth(60); break;}
                    case 1: {column.setPreferredWidth(50); break;}
                    case 2: {column.setPreferredWidth(50); break;}
                    case 3: {column.setPreferredWidth(50); break;}
                    case 4: {column.setPreferredWidth(50); break;}
                    case 5: {column.setPreferredWidth(50); break;}
                    case 6: {column.setPreferredWidth(50); break;}
                    case 7: {column.setPreferredWidth(50); break;}
                    case 8: {column.setPreferredWidth(50); break;}
                    case 9: {column.setPreferredWidth(50); break;}
                    case 10: {column.setPreferredWidth(50); break;}
                    case 11: {column.setPreferredWidth(50); break;}
                    case 12: {column.setPreferredWidth(50); break;}
                    case 13: {column.setPreferredWidth(50); break;}

            }
        }
        //add table to the scrollpane
        table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        javax.swing.JScrollPane jsp = new javax.swing.JScrollPane(table);
       //jsp.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
       //jsp.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        table.setPreferredScrollableViewportSize(new java.awt.Dimension(170,110));
       // table.setPreferredScrollableViewportSize(this.getSize());
        this.add(jsp);
        
        table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        table.setToolTipText("Click on any row to set map to that storm");
        ListSelectionModel rowSM = table.getSelectionModel();
        rowSM.addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                //Ignore extra messages.
                if (e.getValueIsAdjusting()) return;
                
                ListSelectionModel lsm = (ListSelectionModel)e.getSource();
                if (lsm.isSelectionEmpty()) {
                    
                }
                else {
                    int selectedRow = lsm.getMinSelectionIndex();
                    Storm s = (Storm)stormTable.elementAt(selectedRow);
                    
                    //This used to call back to the main program window for displaying the storm
                    java.awt.Frame[] mainProgramInstances = RainScatter.getFrames();
                    RainScatter rs = (RainScatter)mainProgramInstances[0];
                    rs.displayStormFromTable(s);
                }
            }
        });
        
       // setSize(720, 500);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {
        this.setSize(200,300);
        validate();
    }
 
    public void setStormTable(java.util.Vector stormTable) {
        // initComponents();
        
        java.util.Vector stormTableVector = new java.util.Vector();
        
        int numberOfStorms = stormTable.size();
        Object[][] RowData;
        
        
        
        for (int i = 0; i < stormTable.size(); i++) {
            Storm storm = (Storm)stormTable.elementAt(i);
            java.util.Vector lineData = addStorm(storm);
            stormTableVector.add(lineData);
            
        }

        table = new javax.swing.JTable(stormTableVector, getColumnHeader());
        javax.swing.JScrollPane jsp = new javax.swing.JScrollPane(table);
        //jsp.setSize(360,180);
        table.setPreferredScrollableViewportSize(new java.awt.Dimension(200,300));
        
        this.add(jsp);
        validate();
    }
    
    private java.util.Vector addStorm(Storm storm) {
        java.util.Vector lineData = new java.util.Vector();
        
        String grid = getGrid(storm.getLat(), storm.getLon());
        String id = storm.getID();
        String tvs = storm.getTVS();
        String mso = storm.getMSO();
        String posh = new Double(storm.getPOSH()).toString();
        String poh = new Double(storm.getPOH()).toString();
        String maxSize = new Double(storm.getMXSize()).toString();
        String vil = new Double(storm.getVIL()).toString();
        String dBz =new Integer(storm.getDBz()).toString();
        String ht = new Double(storm.getHT()).toString();
        String top = new Double(storm.getTop()).toString();
        String dir = new Integer(storm.getDirection()).toString();
        if (dir.equals("-1")) {
            dir = "NEW";
        }
        String speed = new Integer(storm.getSpeed()).toString();
        if (speed.equals("-1")) {
            speed = "NEW";
        }
        
        String radar = storm.getRadar();
        
        lineData.add(grid);
        lineData.add(top);
        lineData.add(dBz);
        lineData.add(ht);
        lineData.add(dir);
        lineData.add(speed);
        lineData.add(id);
        lineData.add(tvs);
        lineData.add(mso);
        lineData.add(posh);
        lineData.add(poh);
        lineData.add(maxSize);
        lineData.add(vil);
        lineData.add(radar);
        
        return lineData;
        
        
    }
    private java.util.Vector getColumnHeader() {
        java.util.Vector vect = new java.util.Vector();
        vect.add("Grid");
        vect.add("Top");
        vect.add("dBz");
        vect.add("Height");
        vect.add("Dir");
        vect.add("Speed");
        vect.add("ID");
        vect.add("TVS");
        vect.add("MSO");
        vect.add("POSH");
        vect.add("POH");
        vect.add("MXSize");
        vect.add("VIL");
        vect.add("Rad");
        return vect;
    }

    private String getGrid(double lat, double lon) {
        //field = 20 degrees lon, 10 deg lat
        //grid = 2 degrees lon, 1 deg lat
        //subsquare = 2/24 lon, 1/24 lat;
        //'A' = (char)65
        //'0' (zero)  = (char)(48)
        //West is positive
        String str = "";
        char g1;
        char g2;
        char g3;
        char g4;
        char g5;
        char g6;
        g1 = (char)(Math.floor((-lon + 180)/20.0) + 65);  //x
        g2 = (char)(Math.floor(lat/10.0) + 74);  //x
        
        g3 = (char)(Math.floor(((-lon + 180)%20)/2) + 48); //x
        g4 = (char) (Math.floor((lat + 90)%10) + 48);   //x
        
        g5 = (char) (Math.floor(((-lon + 180)%2)/(2.0/24.0)) + 97);
        g6 = (char) ((Math.floor(((lat + 90)%1)/ (1.0/24.0))) + 97);
        str = str + g1 + g2 + g3+ g4 + g5 + g6;
        
        return str;
        
    }
    public JTable getTable() {
        return table;
    }
    class MyTableModel extends javax.swing.table.AbstractTableModel implements TableModelListener {
        
        public boolean isCellEditable(int row, int col) {
            return false;
        }
        
        public int getColumnCount() {
            if (stormTableVector.size() > 0) {
                Object obj = stormTableVector.elementAt(0);
                java.util.Vector vect = (java.util.Vector) obj;
                return vect.size();
            }
            else {
                return 0;
            }
        }
        
        public int getRowCount() {
            return stormTableVector.size();
        }
        
        public Object getValueAt(int row, int col) {
            Object obj = stormTableVector.elementAt(row);
            java.util.Vector vect = (java.util.Vector) obj;
            return vect.elementAt(col);
        }
        public String getColumnName(int col) {
            columnNames = getColumnHeader();
            return (String)columnNames.elementAt(col);
        }
        
        public void tableChanged(TableModelEvent e) {
           // System.out.println("Table changed!");
        }
        
    }
    

}

